module ppu_ctrl (

FSL_S_CLK,
FSL_S_READ,
FSL_S_DATA,
FSL_S_CONTROL,
FSL_S_EXISTS,
ippu_clk,
ippu_reset,
oh_scroll,
ov_scroll,
oppu_disable

);

output FSL_S_CLK;
output FSL_S_READ;
input [0:31] FSL_S_DATA;
input FSL_S_CONTROL;
input FSL_S_EXISTS;
input ippu_clk;
input ippu_reset;
output [9:0] oh_scroll;
output [9:0] ov_scroll;
output oppu_disable;
reg  oppu_disable;
reg [9:0] oh_scroll;
reg [9:0] ov_scroll;

//read whenever there's data in the fifo
assign FSL_S_READ = FSL_S_EXISTS;
assign FSL_S_CLK = ippu_clk;

always @ (posedge ippu_clk) begin
  if (ippu_reset) begin
    oppu_disable <= 1'b0;
	 oh_scroll <= 10'b0;
	 ov_scroll <= 10'b0;
  end
  else begin
    if (FSL_S_READ) begin
	   //store the incoming horizontial and vertical offset
	   oppu_disable <= FSL_S_DATA[3];
		oh_scroll <= FSL_S_DATA[22:31];
		ov_scroll <= FSL_S_DATA[10:19];
	 end
  end
end

endmodule 