module sprite_ctrl(

iat_data,
//ipixel_count,
//iline_count,
isprite_active,
ipt_data,
osram_addr,
ovram_addr,
osprite_pixel,
osprite_enable,
iat_fetch,
ipt_fetch,
ippu_clk,
reset

);

input[0:31] iat_data;
input isprite_active;
//input[8:0] ipixel_count;
//input[8:0] iline_count;
input[0:7] ipt_data;
output[7:0] osram_addr;
output[13:0] ovram_addr;
output[3:0] osprite_pixel;
output osprite_enable;
input ippu_clk;
input reset;

input iat_fetch;
input ipt_fetch;
reg at_fetchq;
reg [8:0] pixel_count;
reg [8:0] line_count;
reg pt_fetchq;

reg [5:0] sram_addr;
//reg [4:0] sram_addrq;
reg [7:0] vram_addr;
reg [3:0] at_fr_addr;
reg [3:0] pt_count;
reg [3:0] pt_countq;
reg [0:31] at_flopRam [0:7];
reg [0:7] pt_flopRam [0:15];
wire [3:0] sprite_pixel;
wire [7:0] sprite_enable;
wire [0:31] sprite0_attr;
wire [0:31] sprite1_attr;
wire [0:31] sprite2_attr;
wire [0:31] sprite3_attr;
wire [0:31] sprite4_attr;
wire [0:31] sprite5_attr;
wire [0:31] sprite6_attr;
wire [0:31] sprite7_attr;
wire [0:7] sprite0_pattern0;
wire [0:7] sprite1_pattern0;
wire [0:7] sprite2_pattern0;
wire [0:7] sprite3_pattern0;
wire [0:7] sprite4_pattern0;
wire [0:7] sprite5_pattern0;
wire [0:7] sprite6_pattern0;
wire [0:7] sprite7_pattern0;
wire [0:7] sprite0_pattern1;
wire [0:7] sprite1_pattern1;
wire [0:7] sprite2_pattern1;
wire [0:7] sprite3_pattern1;
wire [0:7] sprite4_pattern1;
wire [0:7] sprite5_pattern1;
wire [0:7] sprite6_pattern1;
wire [0:7] sprite7_pattern1;
wire [2:0] sprite0_line_index;
wire [2:0] sprite1_line_index;
wire [2:0] sprite2_line_index;
wire [2:0] sprite3_line_index;
wire [2:0] sprite4_line_index;
wire [2:0] sprite5_line_index;
wire [2:0] sprite6_line_index;
wire [2:0] sprite7_line_index;
reg [2:0] sprite_line_index;
assign sprite0_attr = at_flopRam[0];
assign sprite1_attr = at_flopRam[1];
assign sprite2_attr = at_flopRam[2];
assign sprite3_attr = at_flopRam[3];
assign sprite4_attr = at_flopRam[4];
assign sprite5_attr = at_flopRam[5];
assign sprite6_attr = at_flopRam[6];
assign sprite7_attr = at_flopRam[7];
assign sprite0_pattern0 = {pt_flopRam[0]};
assign sprite1_pattern0 = {pt_flopRam[2]};
assign sprite2_pattern0 = {pt_flopRam[4]};
assign sprite3_pattern0 = {pt_flopRam[6]};
assign sprite4_pattern0 = {pt_flopRam[8]};
assign sprite5_pattern0 = {pt_flopRam[10]};
assign sprite6_pattern0 = {pt_flopRam[12]};
assign sprite7_pattern0 = {pt_flopRam[14]};
assign sprite0_pattern1 = {pt_flopRam[1]};
assign sprite1_pattern1 = {pt_flopRam[3]};
assign sprite2_pattern1 = {pt_flopRam[5]};
assign sprite3_pattern1 = {pt_flopRam[7]};
assign sprite4_pattern1 = {pt_flopRam[9]};
assign sprite5_pattern1 = {pt_flopRam[11]};
assign sprite6_pattern1 = {pt_flopRam[13]};
assign sprite7_pattern1 = {pt_flopRam[15]};

//the corresponsing sprite is enable if it falls within the range
assign sprite_enable[0] = ((pixel_count[8:1] >= sprite0_attr[24:31]) && (pixel_count[8:1] < sprite0_attr[24:31] + 4'd8))
								   && ((line_count[8:1] >= sprite0_attr[0:7]) && (line_count[8:1] < sprite0_attr[0:7] + 4'd8));
assign sprite_enable[1] = ((pixel_count[8:1] >= sprite1_attr[24:31]) && (pixel_count[8:1] < sprite1_attr[24:31] + 4'd8))
								   && ((line_count[8:1] >= sprite1_attr[0:7]) && (line_count[8:1] < sprite1_attr[0:7] + 4'd8));
assign sprite_enable[2] = ((pixel_count[8:1] >= sprite2_attr[24:31]) && (pixel_count[8:1] < sprite2_attr[24:31] + 4'd8))
								   && ((line_count[8:1] >= sprite2_attr[0:7]) && (line_count[8:1] < sprite2_attr[0:7] + 4'd8));
assign sprite_enable[3] = ((pixel_count[8:1] >= sprite3_attr[24:31]) && (pixel_count[8:1] < sprite3_attr[24:31] + 4'd8))
								   && ((line_count[8:1] >= sprite3_attr[0:7]) && (line_count[8:1] < sprite3_attr[0:7] + 4'd8));
assign sprite_enable[4] = ((pixel_count[8:1] >= sprite4_attr[24:31]) && (pixel_count[8:1] < sprite4_attr[24:31] + 4'd8))
								   && ((line_count[8:1] >= sprite4_attr[0:7]) && (line_count[8:1] < sprite4_attr[0:7] + 4'd8));
assign sprite_enable[5] = ((pixel_count[8:1] >= sprite5_attr[24:31]) && (pixel_count[8:1] < sprite5_attr[24:31] + 4'd8))
								   && ((line_count[8:1] >= sprite5_attr[0:7]) && (line_count[8:1] < sprite5_attr[0:7] + 4'd8));
assign sprite_enable[6] = ((pixel_count[8:1] >= sprite6_attr[24:31]) && (pixel_count[8:1] < sprite6_attr[24:31] + 4'd8))
								   && ((line_count[8:1] >= sprite6_attr[0:7]) && (line_count[8:1] < sprite6_attr[0:7] + 4'd8));
assign sprite_enable[7] = ((pixel_count[8:1] >= sprite7_attr[24:31]) && (pixel_count[8:1] < sprite7_attr[24:31] + 4'd8))
								   && ((line_count[8:1] >= sprite7_attr[0:7]) && (line_count[8:1] < sprite7_attr[0:7] + 4'd8));

//different pattern will be fetched base on which line of the sprite
//the ppu is currently rendering
assign sprite0_line_index = line_count[8:1] - sprite0_attr[0:7];
assign sprite1_line_index = line_count[8:1] - sprite1_attr[0:7];
assign sprite2_line_index = line_count[8:1] - sprite2_attr[0:7];
assign sprite3_line_index = line_count[8:1] - sprite3_attr[0:7];
assign sprite4_line_index = line_count[8:1] - sprite4_attr[0:7];
assign sprite5_line_index = line_count[8:1] - sprite5_attr[0:7];
assign sprite6_line_index = line_count[8:1] - sprite6_attr[0:7];
assign sprite7_line_index = line_count[8:1] - sprite7_attr[0:7];

//fetch the bit0 and bit1 sprite pattern
assign ovram_addr = pt_count[0] == 1'b0 ? {2'b0,vram_addr,4'b0} + sprite_line_index :
														{2'b0,vram_addr,4'b0} + 4'd8 + sprite_line_index;

assign osram_addr = sram_addr << 2;
assign osprite_pixel = sprite_pixel;

//enable is the sprites are in range and the enable bit is 0
assign osprite_enable = (!sprite0_attr[18] & sprite_enable[0]) | (!sprite1_attr[18] & sprite_enable[1]) |
								(!sprite2_attr[18] & sprite_enable[2]) | (!sprite3_attr[18] & sprite_enable[3]) |
								(!sprite4_attr[18] & sprite_enable[4]) | (!sprite5_attr[18] & sprite_enable[5]) |
								(!sprite6_attr[18] & sprite_enable[6]) | (!sprite7_attr[18] & sprite_enable[7]);
																
always @ (pt_count[3:1]) begin
  case (pt_count[3:1])
    //use the pattern number in the attribute to fetch the pattern
    3'b000: vram_addr = sprite0_attr[8:15];
	 3'b001: vram_addr = sprite1_attr[8:15];
	 3'b010: vram_addr = sprite2_attr[8:15];
	 3'b011: vram_addr = sprite3_attr[8:15];
	 3'b100: vram_addr = sprite4_attr[8:15];
	 3'b101: vram_addr = sprite5_attr[8:15];
	 3'b110: vram_addr = sprite6_attr[8:15];
	 3'b111: vram_addr = sprite7_attr[8:15];
	 default: vram_addr = 8'b0;
  endcase
end

always @ (pt_count[3:1]) begin
  case (pt_count[3:1])
    3'b000: sprite_line_index = sprite0_line_index;
	 3'b001: sprite_line_index = sprite1_line_index;
	 3'b010: sprite_line_index = sprite2_line_index;
	 3'b011: sprite_line_index = sprite3_line_index;
	 3'b100: sprite_line_index = sprite4_line_index;
	 3'b101: sprite_line_index = sprite5_line_index;
	 3'b110: sprite_line_index = sprite6_line_index;
	 3'b111: sprite_line_index = sprite7_line_index;
	 default: sprite_line_index = 8'b0;
  endcase
end

always @ (posedge ippu_clk) begin
  if(reset) begin
    sram_addr <= 6'b0;
	 at_fr_addr <= 4'b0;
	 at_fetchq <= 1'b0;
	 pt_fetchq <= 1'b0;
	 pt_countq <= 4'b0;
	 pt_count <= 4'b0;
	 pixel_count <= 9'b0;
	 line_count <= 9'b0;
  end
  else begin
    if (isprite_active)
	   pixel_count <= pixel_count + 1'b1;
    else 
	   pixel_count <= 0;
		
    if (pixel_count == 9'd511) begin //fetch an extra 8 pixels for horizontal scrolling
	   if (line_count[8:1] == 8'd239)
	     line_count <= 9'b0;
      else
	     line_count <= line_count + 1'b1;		  
	 end  
    at_fetchq <= iat_fetch;
	 pt_fetchq <= ipt_fetch;
	// sram_addr = sram_addrq;
	 pt_countq <= pt_count;
	 
    if(iat_fetch)
	   sram_addr <= sram_addr + 1'b1;
	 	 
	 
	 //fetch the 64 sprite attribute, store them if they'll be appearing in the next line
	 if(at_fetchq) begin
	   if((line_count[8:1] >= iat_data[0:7]) && ( line_count[8:1] < iat_data[0:7] + 4'd8) 
			&& (at_fr_addr < 4'b1000) && !iat_data[18]) begin  
		  at_fr_addr <= at_fr_addr + 1'b1;
		end
	 end
	 else
	   at_fr_addr <= 4'b0;
	 
	 if(at_fetchq) begin
	   if((line_count[8:1] >= iat_data[0:7]) && ( line_count[8:1] < iat_data[0:7] + 4'd8) 
			&& (at_fr_addr < 4'b1000) && !iat_data[18]) begin  
			at_flopRam[at_fr_addr] <= iat_data;
		end
	 end
	 
	 if(ipt_fetch)
	   pt_count <= pt_count + 1'b1;
	 
	 if(pt_fetchq)
	   pt_flopRam[pt_countq] <= ipt_data;
				
  end
end
	   
	  
sprite_render sprite_render_inst0(

.isprite_enable(sprite_enable),
.isprite0_pattern0(sprite0_pattern0),
.isprite1_pattern0(sprite1_pattern0),
.isprite2_pattern0(sprite2_pattern0),
.isprite3_pattern0(sprite3_pattern0),
.isprite4_pattern0(sprite4_pattern0),
.isprite5_pattern0(sprite5_pattern0),
.isprite6_pattern0(sprite6_pattern0),
.isprite7_pattern0(sprite7_pattern0),
.isprite0_pattern1(sprite0_pattern1),
.isprite1_pattern1(sprite1_pattern1),
.isprite2_pattern1(sprite2_pattern1),
.isprite3_pattern1(sprite3_pattern1),
.isprite4_pattern1(sprite4_pattern1),
.isprite5_pattern1(sprite5_pattern1),
.isprite6_pattern1(sprite6_pattern1),
.isprite7_pattern1(sprite7_pattern1),
.isprite_palette({sprite7_attr[22:23],sprite6_attr[22:23],sprite5_attr[22:23],sprite4_attr[22:23],sprite3_attr[22:23],sprite2_attr[22:23],sprite1_attr[22:23],sprite0_attr[22:23]}),
.osprite_pixel(sprite_pixel),
.ippu_clk(ippu_clk),
.reset(reset)

);
endmodule 