module sprite_pix_mux(

isprite_enable,
isprite_pattern0,
isprite_pattern1,
osprite_color,
ippu_clk,
reset

);

input isprite_enable;
input[7:0] isprite_pattern0;
input[7:0] isprite_pattern1;
output[1:0] osprite_color;
input ippu_clk;
input reset;

reg [3:0] pixel_count;
reg [1:0] osprite_color;
always @ (posedge ippu_clk) begin
  if (reset) begin
    pixel_count <= 4'b0;
  end
  else begin
    if (isprite_enable)
	   pixel_count <= pixel_count + 1'b1;
	 else 
	   pixel_count <= 4'b0;
  end
end
//output 2 bits per pixel, chosen from the two 8-bits pattern data
//two 8-bits correspond to 8 pixel on the screen
always @ (pixel_count or isprite_pattern0 or isprite_pattern1) begin
  case (pixel_count[3:1]) 
	 3'b000: osprite_color = {isprite_pattern1[7], isprite_pattern0[7]};
	 3'b001: osprite_color = {isprite_pattern1[6], isprite_pattern0[6]};
	 3'b010: osprite_color = {isprite_pattern1[5], isprite_pattern0[5]};
	 3'b011: osprite_color = {isprite_pattern1[4], isprite_pattern0[4]};
	 3'b100: osprite_color = {isprite_pattern1[3], isprite_pattern0[3]};
	 3'b101: osprite_color = {isprite_pattern1[2], isprite_pattern0[2]};
	 3'b110: osprite_color = {isprite_pattern1[1], isprite_pattern0[1]};
	 3'b111: osprite_color = {isprite_pattern1[0], isprite_pattern0[0]};
	 default: osprite_color = 2'b0;
  endcase
end

endmodule 