module sprite_render(

isprite_enable,
//isprite_enable,
//isprite_offset,
isprite0_pattern0,
isprite1_pattern0,
isprite2_pattern0,
isprite3_pattern0,
isprite4_pattern0,
isprite5_pattern0,
isprite6_pattern0,
isprite7_pattern0,
isprite0_pattern1,
isprite1_pattern1,
isprite2_pattern1,
isprite3_pattern1,
isprite4_pattern1,
isprite5_pattern1,
isprite6_pattern1,
isprite7_pattern1,
isprite_palette,
osprite_pixel,
ippu_clk,
reset

);
input[7:0] isprite_enable;
//isprite_enable,
//isprite_offset,
input[7:0] isprite0_pattern0;
input[7:0] isprite1_pattern0;
input[7:0] isprite2_pattern0;
input[7:0] isprite3_pattern0;
input[7:0] isprite4_pattern0;
input[7:0] isprite5_pattern0;
input[7:0] isprite6_pattern0;
input[7:0] isprite7_pattern0;
input[7:0] isprite0_pattern1;
input[7:0] isprite1_pattern1;
input[7:0] isprite2_pattern1;
input[7:0] isprite3_pattern1;
input[7:0] isprite4_pattern1;
input[7:0] isprite5_pattern1;
input[7:0] isprite6_pattern1;
input[7:0] isprite7_pattern1;
input[15:0] isprite_palette;
output[3:0] osprite_pixel;
input ippu_clk;
input reset;
wire[1:0] sprite_color0;
wire[1:0] sprite_color1;
wire[1:0] sprite_color2;
wire[1:0] sprite_color3;
wire[1:0] sprite_color4;
wire[1:0] sprite_color5;
wire[1:0] sprite_color6;
wire[1:0] sprite_color7;
reg[3:0] osprite_pixel;


//prioritize the eight sprite
//output the highest the sprite with the highest priority if they overlap
always @ (sprite_color0 or sprite_color1 or sprite_color2 or sprite_color3 or
			sprite_color4 or sprite_color5 or sprite_color6 or sprite_color7 or isprite_enable) begin
  osprite_pixel = 4'b0;
  if (isprite_enable[0])
    osprite_pixel = {isprite_palette[1:0], sprite_color0};
  else if (isprite_enable[1])
    osprite_pixel = {isprite_palette[3:2], sprite_color1};
  else if (isprite_enable[2])
    osprite_pixel = {isprite_palette[5:4], sprite_color2};	 
   else if (isprite_enable[3])
    osprite_pixel = {isprite_palette[7:6], sprite_color3}; 
   else if (isprite_enable[4])
    osprite_pixel = {isprite_palette[9:8], sprite_color4}; 
   else if (isprite_enable[5])
    osprite_pixel = {isprite_palette[11:10], sprite_color5};
  else if (isprite_enable[6])
    osprite_pixel = {isprite_palette[13:12], sprite_color6};
  else if (isprite_enable[7])
    osprite_pixel = {isprite_palette[15:14], sprite_color7};
end	 


sprite_pix_mux sprite_pix_mux0(

.isprite_enable(isprite_enable[0]),
.isprite_pattern0(isprite0_pattern0),
.isprite_pattern1(isprite0_pattern1),
.osprite_color(sprite_color0),
.ippu_clk(ippu_clk),
.reset(reset)

);
sprite_pix_mux sprite_pix_mux1(

.isprite_enable(isprite_enable[1]),
.isprite_pattern0(isprite1_pattern0),
.isprite_pattern1(isprite1_pattern1),
.osprite_color(sprite_color1),
.ippu_clk(ippu_clk),
.reset(reset)

);
sprite_pix_mux sprite_pix_mux2(

.isprite_enable(isprite_enable[2]),
.isprite_pattern0(isprite2_pattern0),
.isprite_pattern1(isprite2_pattern1),
.osprite_color(sprite_color2),
.ippu_clk(ippu_clk),
.reset(reset)

);
sprite_pix_mux sprite_pix_mux3(

.isprite_enable(isprite_enable[3]),
.isprite_pattern0(isprite3_pattern0),
.isprite_pattern1(isprite3_pattern1),
.osprite_color(sprite_color3),
.ippu_clk(ippu_clk),
.reset(reset)

);
sprite_pix_mux sprite_pix_mux4(

.isprite_enable(isprite_enable[4]),
.isprite_pattern0(isprite4_pattern0),
.isprite_pattern1(isprite4_pattern1),
.osprite_color(sprite_color4),
.ippu_clk(ippu_clk),
.reset(reset)

);
sprite_pix_mux sprite_pix_mux5(

.isprite_enable(isprite_enable[5]),
.isprite_pattern0(isprite5_pattern0),
.isprite_pattern1(isprite5_pattern1),
.osprite_color(sprite_color5),
.ippu_clk(ippu_clk),
.reset(reset)

);
sprite_pix_mux sprite_pix_mux6(

.isprite_enable(isprite_enable[6]),
.isprite_pattern0(isprite6_pattern0),
.isprite_pattern1(isprite6_pattern1),
.osprite_color(sprite_color6),
.ippu_clk(ippu_clk),
.reset(reset)

);

sprite_pix_mux sprite_pix_mux7(

.isprite_enable(isprite_enable[7]),
.isprite_pattern0(isprite7_pattern0),
.isprite_pattern1(isprite7_pattern1),
.osprite_color(sprite_color7),
.ippu_clk(ippu_clk),
.reset(reset)

);

endmodule 