//-----------------------------------------------------------------------------
// opb_bram_if_cntlr_1_vram_elaborate.v
//-----------------------------------------------------------------------------

`timescale 1 ns/10 ps

`uselib lib=unisims_ver

module opb_bram_if_cntlr_1_vram_elaborate
  (
    BRAM_Rst_A,
    BRAM_Clk_A,
    BRAM_EN_A,
    BRAM_WEN_A,
    BRAM_Addr_A,
    BRAM_Din_A,
    BRAM_Dout_A,
    BRAM_Rst_B,
    BRAM_Clk_B,
    BRAM_EN_B,
    BRAM_WEN_B,
    BRAM_Addr_B,
    BRAM_Din_B,
    BRAM_Dout_B
  );
  parameter
    C_MEMSIZE = 'h10000,
    C_PORT_DWIDTH = 32,
    C_PORT_AWIDTH = 32,
    C_NUM_WE = 4,
    C_FAMILY = "virtex2p";
  input BRAM_Rst_A;
  input BRAM_Clk_A;
  input BRAM_EN_A;
  input [0:C_NUM_WE-1] BRAM_WEN_A;
  input [0:C_PORT_AWIDTH-1] BRAM_Addr_A;
  output [0:C_PORT_DWIDTH-1] BRAM_Din_A;
  input [0:C_PORT_DWIDTH-1] BRAM_Dout_A;
  input BRAM_Rst_B;
  input BRAM_Clk_B;
  input BRAM_EN_B;
  input [0:C_NUM_WE-1] BRAM_WEN_B;
  input [0:C_PORT_AWIDTH-1] BRAM_Addr_B;
  output [0:C_PORT_DWIDTH-1] BRAM_Din_B;
  input [0:C_PORT_DWIDTH-1] BRAM_Dout_B;

  // Internal signals

  wire [31:0] dina;
  wire [31:0] dinb;
  wire [31:0] douta;
  wire [31:0] doutb;

  // Internal assignments

  assign dina[31:0] = BRAM_Dout_A[0:31];
  assign BRAM_Din_A[0:31] = douta[31:0];
  assign dinb[31:0] = BRAM_Dout_B[0:31];
  assign BRAM_Din_B[0:31] = doutb[31:0];

  defparam ramb16_s1_s1_0.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_0.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_0 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[31:31] ),
      .DOA ( douta[31:31] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[0] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[31:31] ),
      .DOB ( doutb[31:31] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[0] )
    );

  defparam ramb16_s1_s1_1.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_1.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_1 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[30:30] ),
      .DOA ( douta[30:30] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[0] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[30:30] ),
      .DOB ( doutb[30:30] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[0] )
    );

  defparam ramb16_s1_s1_2.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_2.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_2 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[29:29] ),
      .DOA ( douta[29:29] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[0] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[29:29] ),
      .DOB ( doutb[29:29] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[0] )
    );

  defparam ramb16_s1_s1_3.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_3.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_3 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[28:28] ),
      .DOA ( douta[28:28] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[0] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[28:28] ),
      .DOB ( doutb[28:28] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[0] )
    );

  defparam ramb16_s1_s1_4.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_4.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_4 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[27:27] ),
      .DOA ( douta[27:27] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[0] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[27:27] ),
      .DOB ( doutb[27:27] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[0] )
    );

  defparam ramb16_s1_s1_5.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_5.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_5 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[26:26] ),
      .DOA ( douta[26:26] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[0] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[26:26] ),
      .DOB ( doutb[26:26] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[0] )
    );

  defparam ramb16_s1_s1_6.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_6.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_6 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[25:25] ),
      .DOA ( douta[25:25] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[0] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[25:25] ),
      .DOB ( doutb[25:25] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[0] )
    );

  defparam ramb16_s1_s1_7.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_7.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_7 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[24:24] ),
      .DOA ( douta[24:24] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[0] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[24:24] ),
      .DOB ( doutb[24:24] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[0] )
    );

  defparam ramb16_s1_s1_8.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_8.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_8 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[23:23] ),
      .DOA ( douta[23:23] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[1] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[23:23] ),
      .DOB ( doutb[23:23] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[1] )
    );

  defparam ramb16_s1_s1_9.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_9.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_9 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[22:22] ),
      .DOA ( douta[22:22] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[1] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[22:22] ),
      .DOB ( doutb[22:22] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[1] )
    );

  defparam ramb16_s1_s1_10.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_10.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_10 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[21:21] ),
      .DOA ( douta[21:21] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[1] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[21:21] ),
      .DOB ( doutb[21:21] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[1] )
    );

  defparam ramb16_s1_s1_11.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_11.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_11 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[20:20] ),
      .DOA ( douta[20:20] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[1] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[20:20] ),
      .DOB ( doutb[20:20] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[1] )
    );

  defparam ramb16_s1_s1_12.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_12.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_12 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[19:19] ),
      .DOA ( douta[19:19] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[1] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[19:19] ),
      .DOB ( doutb[19:19] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[1] )
    );

  defparam ramb16_s1_s1_13.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_13.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_13 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[18:18] ),
      .DOA ( douta[18:18] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[1] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[18:18] ),
      .DOB ( doutb[18:18] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[1] )
    );

  defparam ramb16_s1_s1_14.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_14.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_14 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[17:17] ),
      .DOA ( douta[17:17] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[1] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[17:17] ),
      .DOB ( doutb[17:17] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[1] )
    );

  defparam ramb16_s1_s1_15.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_15.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_15 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[16:16] ),
      .DOA ( douta[16:16] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[1] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[16:16] ),
      .DOB ( doutb[16:16] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[1] )
    );

  defparam ramb16_s1_s1_16.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_16.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_16 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[15:15] ),
      .DOA ( douta[15:15] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[2] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[15:15] ),
      .DOB ( doutb[15:15] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[2] )
    );

  defparam ramb16_s1_s1_17.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_17.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_17 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[14:14] ),
      .DOA ( douta[14:14] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[2] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[14:14] ),
      .DOB ( doutb[14:14] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[2] )
    );

  defparam ramb16_s1_s1_18.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_18.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_18 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[13:13] ),
      .DOA ( douta[13:13] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[2] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[13:13] ),
      .DOB ( doutb[13:13] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[2] )
    );

  defparam ramb16_s1_s1_19.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_19.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_19 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[12:12] ),
      .DOA ( douta[12:12] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[2] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[12:12] ),
      .DOB ( doutb[12:12] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[2] )
    );

  defparam ramb16_s1_s1_20.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_20.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_20 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[11:11] ),
      .DOA ( douta[11:11] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[2] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[11:11] ),
      .DOB ( doutb[11:11] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[2] )
    );

  defparam ramb16_s1_s1_21.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_21.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_21 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[10:10] ),
      .DOA ( douta[10:10] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[2] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[10:10] ),
      .DOB ( doutb[10:10] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[2] )
    );

  defparam ramb16_s1_s1_22.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_22.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_22 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[9:9] ),
      .DOA ( douta[9:9] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[2] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[9:9] ),
      .DOB ( doutb[9:9] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[2] )
    );

  defparam ramb16_s1_s1_23.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_23.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_23 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[8:8] ),
      .DOA ( douta[8:8] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[2] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[8:8] ),
      .DOB ( doutb[8:8] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[2] )
    );

  defparam ramb16_s1_s1_24.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_24.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_24 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[7:7] ),
      .DOA ( douta[7:7] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[3] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[7:7] ),
      .DOB ( doutb[7:7] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[3] )
    );

  defparam ramb16_s1_s1_25.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_25.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_25 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[6:6] ),
      .DOA ( douta[6:6] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[3] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[6:6] ),
      .DOB ( doutb[6:6] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[3] )
    );

  defparam ramb16_s1_s1_26.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_26.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_26 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[5:5] ),
      .DOA ( douta[5:5] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[3] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[5:5] ),
      .DOB ( doutb[5:5] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[3] )
    );

  defparam ramb16_s1_s1_27.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_27.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_27 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[4:4] ),
      .DOA ( douta[4:4] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[3] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[4:4] ),
      .DOB ( doutb[4:4] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[3] )
    );

  defparam ramb16_s1_s1_28.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_28.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_28 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[3:3] ),
      .DOA ( douta[3:3] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[3] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[3:3] ),
      .DOB ( doutb[3:3] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[3] )
    );

  defparam ramb16_s1_s1_29.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_29.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_29 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[2:2] ),
      .DOA ( douta[2:2] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[3] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[2:2] ),
      .DOB ( doutb[2:2] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[3] )
    );

  defparam ramb16_s1_s1_30.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_30.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_30 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[1:1] ),
      .DOA ( douta[1:1] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[3] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[1:1] ),
      .DOB ( doutb[1:1] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[3] )
    );

  defparam ramb16_s1_s1_31.WRITE_MODE_A = "WRITE_FIRST";
  defparam ramb16_s1_s1_31.WRITE_MODE_B = "WRITE_FIRST";
  RAMB16_S1_S1
    ramb16_s1_s1_31 (
      .ADDRA ( BRAM_Addr_A[16:29] ),
      .CLKA ( BRAM_Clk_A ),
      .DIA ( dina[0:0] ),
      .DOA ( douta[0:0] ),
      .ENA ( BRAM_EN_A ),
      .SSRA ( BRAM_Rst_A ),
      .WEA ( BRAM_WEN_A[3] ),
      .ADDRB ( BRAM_Addr_B[16:29] ),
      .CLKB ( BRAM_Clk_B ),
      .DIB ( dinb[0:0] ),
      .DOB ( doutb[0:0] ),
      .ENB ( BRAM_EN_B ),
      .SSRB ( BRAM_Rst_B ),
      .WEB ( BRAM_WEN_B[3] )
    );

endmodule

