//-----------------------------------------------------------------------------
// system.v
//-----------------------------------------------------------------------------

`timescale 1 ns/10 ps

`uselib lib=unisims_ver

module system
  (
    fpga_0_RS232_Uart_1_RX_pin,
    fpga_0_RS232_Uart_1_TX_pin,
    fpga_0_net_gnd_pin,
    fpga_0_net_gnd_1_pin,
    fpga_0_net_gnd_2_pin,
    fpga_0_net_gnd_3_pin,
    fpga_0_net_gnd_4_pin,
    fpga_0_net_gnd_5_pin,
    fpga_0_net_gnd_6_pin,
    sys_clk_pin,
    sys_rst_pin,
    VGA_OUT_PIXEL_CLOCK,
    VGA_COMP_SYNCH_N,
    VGA_OUT_BLANK_N,
    VGA_HSYNCH,
    VGA_VSYNCH,
    VGA_OUT_RED,
    VGA_OUT_GREEN,
    VGA_OUT_BLUE
  );
  input fpga_0_RS232_Uart_1_RX_pin;
  output fpga_0_RS232_Uart_1_TX_pin;
  output fpga_0_net_gnd_pin;
  output fpga_0_net_gnd_1_pin;
  output fpga_0_net_gnd_2_pin;
  output fpga_0_net_gnd_3_pin;
  output fpga_0_net_gnd_4_pin;
  output fpga_0_net_gnd_5_pin;
  output fpga_0_net_gnd_6_pin;
  input sys_clk_pin;
  input sys_rst_pin;
  output VGA_OUT_PIXEL_CLOCK;
  output VGA_COMP_SYNCH_N;
  output VGA_OUT_BLANK_N;
  output VGA_HSYNCH;
  output VGA_VSYNCH;
  output [0:7] VGA_OUT_RED;
  output [0:7] VGA_OUT_GREEN;
  output [0:7] VGA_OUT_BLUE;

  // Internal signals

  wire Dbg_Capture;
  wire Dbg_Clk;
  wire [0:4] Dbg_Reg_En;
  wire Dbg_TDI;
  wire Dbg_TDO;
  wire Dbg_Update;
  wire Debug_Rst;
  wire Ext_BRK;
  wire Ext_NM_BRK;
  wire dcm_0_FB;
  wire dcm_0_lock;
  wire dcm_clk_s;
  wire display_0_VGA_COMP_SYNCH_N;
  wire display_0_VGA_HSYNCH_N;
  wire display_0_VGA_OUT_BLANK_N;
  wire [0:7] display_0_VGA_OUT_BLUE_P;
  wire [0:7] display_0_VGA_OUT_GREEN_P;
  wire display_0_VGA_OUT_PIXEL_CLOCK_P;
  wire [0:7] display_0_VGA_OUT_RED_P;
  wire display_0_VGA_VSYNCH_N;
  wire [0:31] dlmb_LMB_ABus;
  wire dlmb_LMB_AddrStrobe;
  wire [0:3] dlmb_LMB_BE;
  wire [0:31] dlmb_LMB_ReadDBus;
  wire dlmb_LMB_ReadStrobe;
  wire dlmb_LMB_Ready;
  wire [0:31] dlmb_LMB_WriteDBus;
  wire dlmb_LMB_WriteStrobe;
  wire [0:31] dlmb_M_ABus;
  wire dlmb_M_AddrStrobe;
  wire [0:3] dlmb_M_BE;
  wire [0:31] dlmb_M_DBus;
  wire dlmb_M_ReadStrobe;
  wire dlmb_M_WriteStrobe;
  wire dlmb_OPB_Rst;
  wire [0:31] dlmb_Sl_DBus;
  wire [0:0] dlmb_Sl_Ready;
  wire [0:31] dlmb_cntlr_BRAM_PORT_BRAM_Addr;
  wire dlmb_cntlr_BRAM_PORT_BRAM_Clk;
  wire [0:31] dlmb_cntlr_BRAM_PORT_BRAM_Din;
  wire [0:31] dlmb_cntlr_BRAM_PORT_BRAM_Dout;
  wire dlmb_cntlr_BRAM_PORT_BRAM_EN;
  wire dlmb_cntlr_BRAM_PORT_BRAM_Rst;
  wire [0:3] dlmb_cntlr_BRAM_PORT_BRAM_WEN;
  wire fpga_0_RS232_Uart_1_RX;
  wire fpga_0_RS232_Uart_1_TX;
  wire fsl_v20_0_FSL_M_Control;
  wire [0:31] fsl_v20_0_FSL_M_Data;
  wire fsl_v20_0_FSL_M_Full;
  wire fsl_v20_0_FSL_M_Write;
  wire fsl_v20_0_FSL_S_Control;
  wire [0:31] fsl_v20_0_FSL_S_Data;
  wire fsl_v20_0_FSL_S_Exists;
  wire fsl_v20_0_FSL_S_Read;
  wire [0:31] ilmb_LMB_ABus;
  wire ilmb_LMB_AddrStrobe;
  wire [0:3] ilmb_LMB_BE;
  wire [0:31] ilmb_LMB_ReadDBus;
  wire ilmb_LMB_ReadStrobe;
  wire ilmb_LMB_Ready;
  wire [0:31] ilmb_LMB_WriteDBus;
  wire ilmb_LMB_WriteStrobe;
  wire [0:31] ilmb_M_ABus;
  wire ilmb_M_AddrStrobe;
  wire ilmb_M_ReadStrobe;
  wire ilmb_OPB_Rst;
  wire [0:31] ilmb_Sl_DBus;
  wire [0:0] ilmb_Sl_Ready;
  wire [0:31] ilmb_cntlr_BRAM_PORT_BRAM_Addr;
  wire ilmb_cntlr_BRAM_PORT_BRAM_Clk;
  wire [0:31] ilmb_cntlr_BRAM_PORT_BRAM_Din;
  wire [0:31] ilmb_cntlr_BRAM_PORT_BRAM_Dout;
  wire ilmb_cntlr_BRAM_PORT_BRAM_EN;
  wire ilmb_cntlr_BRAM_PORT_BRAM_Rst;
  wire [0:3] ilmb_cntlr_BRAM_PORT_BRAM_WEN;
  wire mb_opb_Debug_SYS_Rst;
  wire [0:63] mb_opb_M_ABus;
  wire [0:7] mb_opb_M_BE;
  wire [0:63] mb_opb_M_DBus;
  wire [0:1] mb_opb_M_RNW;
  wire [0:1] mb_opb_M_busLock;
  wire [0:1] mb_opb_M_request;
  wire [0:1] mb_opb_M_select;
  wire [0:1] mb_opb_M_seqAddr;
  wire [0:31] mb_opb_OPB_ABus;
  wire [0:3] mb_opb_OPB_BE;
  wire [0:31] mb_opb_OPB_DBus;
  wire [0:1] mb_opb_OPB_MGrant;
  wire mb_opb_OPB_RNW;
  wire mb_opb_OPB_Rst;
  wire mb_opb_OPB_errAck;
  wire mb_opb_OPB_retry;
  wire mb_opb_OPB_select;
  wire mb_opb_OPB_seqAddr;
  wire mb_opb_OPB_timeout;
  wire mb_opb_OPB_xferAck;
  wire [0:95] mb_opb_Sl_DBus;
  wire [0:2] mb_opb_Sl_errAck;
  wire [0:2] mb_opb_Sl_retry;
  wire [0:2] mb_opb_Sl_toutSup;
  wire [0:2] mb_opb_Sl_xferAck;
  wire net_gnd0;
  wire [0:1] net_gnd2;
  wire [0:2] net_gnd3;
  wire [0:3] net_gnd4;
  wire [0:31] net_gnd32;
  wire [0:1] net_vcc2;
  wire [0:2] net_vcc3;
  wire [0:31] opb_bram_if_cntlr_1_PORTA_BRAM_Addr;
  wire opb_bram_if_cntlr_1_PORTA_BRAM_Clk;
  wire [0:31] opb_bram_if_cntlr_1_PORTA_BRAM_Din;
  wire [0:31] opb_bram_if_cntlr_1_PORTA_BRAM_Dout;
  wire opb_bram_if_cntlr_1_PORTA_BRAM_EN;
  wire opb_bram_if_cntlr_1_PORTA_BRAM_Rst;
  wire [0:3] opb_bram_if_cntlr_1_PORTA_BRAM_WEN;
  wire pixel_clock;
  wire ppu_active;
  wire [0:23] ppu_fram_Dout;
  wire [0:31] ppu_vram_addr;
  wire ppu_vram_en;
  wire [0:3] ppu_vram_wen;
  wire [0:0] sys_bus_reset;
  wire sys_clk_s;
  wire sys_rst_s;
  wire [0:31] vram_ppu_Din;

  // Internal assignments

  assign fpga_0_RS232_Uart_1_RX = fpga_0_RS232_Uart_1_RX_pin;
  assign fpga_0_RS232_Uart_1_TX_pin = fpga_0_RS232_Uart_1_TX;
  assign dcm_clk_s = sys_clk_pin;
  assign sys_rst_s = sys_rst_pin;
  assign VGA_OUT_PIXEL_CLOCK = display_0_VGA_OUT_PIXEL_CLOCK_P;
  assign VGA_COMP_SYNCH_N = display_0_VGA_COMP_SYNCH_N;
  assign VGA_OUT_BLANK_N = display_0_VGA_OUT_BLANK_N;
  assign VGA_HSYNCH = display_0_VGA_HSYNCH_N;
  assign VGA_VSYNCH = display_0_VGA_VSYNCH_N;
  assign VGA_OUT_RED = display_0_VGA_OUT_RED_P;
  assign VGA_OUT_GREEN = display_0_VGA_OUT_GREEN_P;
  assign VGA_OUT_BLUE = display_0_VGA_OUT_BLUE_P;
  assign net_gnd0 = 1'b0;
  assign fpga_0_net_gnd_pin = net_gnd0;
  assign fpga_0_net_gnd_1_pin = net_gnd0;
  assign fpga_0_net_gnd_2_pin = net_gnd0;
  assign fpga_0_net_gnd_3_pin = net_gnd0;
  assign fpga_0_net_gnd_4_pin = net_gnd0;
  assign fpga_0_net_gnd_5_pin = net_gnd0;
  assign fpga_0_net_gnd_6_pin = net_gnd0;
  assign net_gnd2[0:1] = 2'b00;
  assign net_gnd3[0:2] = 3'b000;
  assign net_gnd32[0:31] = 32'b00000000000000000000000000000000;
  assign net_gnd4[0:3] = 4'b0000;
  assign net_vcc2[0:1] = 2'b11;
  assign net_vcc3[0:2] = 3'b111;

  color_char_mode_svga_ctrl_0_wrapper
    color_char_mode_svga_ctrl_0 (
      .VGA_OUT_PIXEL_CLOCK ( display_0_VGA_OUT_PIXEL_CLOCK_P ),
      .VGA_COMP_SYNCH_N ( display_0_VGA_COMP_SYNCH_N ),
      .VGA_OUT_BLANK_N ( display_0_VGA_OUT_BLANK_N ),
      .VGA_HSYNCH ( display_0_VGA_HSYNCH_N ),
      .VGA_VSYNCH ( display_0_VGA_VSYNCH_N ),
      .VGA_OUT_RED ( display_0_VGA_OUT_RED_P[0:7] ),
      .VGA_OUT_GREEN ( display_0_VGA_OUT_GREEN_P[0:7] ),
      .VGA_OUT_BLUE ( display_0_VGA_OUT_BLUE_P[0:7] ),
      .bram_char_addr (  ),
      .bram_wen (  ),
      .BRAM_Din ( ppu_fram_Dout ),
      .char_read_enable (  ),
      .ppu_active ( ppu_active ),
      .pixel_clock ( pixel_clock ),
      .reset ( sys_bus_reset[0] )
    );

  microblaze_0_wrapper
    microblaze_0 (
      .CLK ( sys_clk_s ),
      .RESET ( mb_opb_OPB_Rst ),
      .INTERRUPT ( net_gnd0 ),
      .DEBUG_RST ( Debug_Rst ),
      .EXT_BRK ( Ext_BRK ),
      .EXT_NM_BRK ( Ext_NM_BRK ),
      .DBG_STOP ( net_gnd0 ),
      .MB_Halted (  ),
      .INSTR ( ilmb_LMB_ReadDBus ),
      .I_ADDRTAG (  ),
      .IREADY ( ilmb_LMB_Ready ),
      .IWAIT ( net_gnd0 ),
      .INSTR_ADDR ( ilmb_M_ABus ),
      .IFETCH ( ilmb_M_ReadStrobe ),
      .I_AS ( ilmb_M_AddrStrobe ),
      .DATA_READ ( dlmb_LMB_ReadDBus ),
      .DREADY ( dlmb_LMB_Ready ),
      .DWAIT ( net_gnd0 ),
      .DATA_WRITE ( dlmb_M_DBus ),
      .DATA_ADDR ( dlmb_M_ABus ),
      .D_ADDRTAG (  ),
      .D_AS ( dlmb_M_AddrStrobe ),
      .READ_STROBE ( dlmb_M_ReadStrobe ),
      .WRITE_STROBE ( dlmb_M_WriteStrobe ),
      .BYTE_ENABLE ( dlmb_M_BE ),
      .DM_ABUS ( mb_opb_M_ABus[0:31] ),
      .DM_BE ( mb_opb_M_BE[0:3] ),
      .DM_BUSLOCK ( mb_opb_M_busLock[0] ),
      .DM_DBUS ( mb_opb_M_DBus[0:31] ),
      .DM_REQUEST ( mb_opb_M_request[0] ),
      .DM_RNW ( mb_opb_M_RNW[0] ),
      .DM_SELECT ( mb_opb_M_select[0] ),
      .DM_SEQADDR ( mb_opb_M_seqAddr[0] ),
      .DOPB_DBUS ( mb_opb_OPB_DBus ),
      .DOPB_ERRACK ( mb_opb_OPB_errAck ),
      .DOPB_MGRANT ( mb_opb_OPB_MGrant[0] ),
      .DOPB_RETRY ( mb_opb_OPB_retry ),
      .DOPB_TIMEOUT ( mb_opb_OPB_timeout ),
      .DOPB_XFERACK ( mb_opb_OPB_xferAck ),
      .IM_ABUS ( mb_opb_M_ABus[32:63] ),
      .IM_BE ( mb_opb_M_BE[4:7] ),
      .IM_BUSLOCK ( mb_opb_M_busLock[1] ),
      .IM_DBUS ( mb_opb_M_DBus[32:63] ),
      .IM_REQUEST ( mb_opb_M_request[1] ),
      .IM_RNW ( mb_opb_M_RNW[1] ),
      .IM_SELECT ( mb_opb_M_select[1] ),
      .IM_SEQADDR ( mb_opb_M_seqAddr[1] ),
      .IOPB_DBUS ( mb_opb_OPB_DBus ),
      .IOPB_ERRACK ( mb_opb_OPB_errAck ),
      .IOPB_MGRANT ( mb_opb_OPB_MGrant[1] ),
      .IOPB_RETRY ( mb_opb_OPB_retry ),
      .IOPB_TIMEOUT ( mb_opb_OPB_timeout ),
      .IOPB_XFERACK ( mb_opb_OPB_xferAck ),
      .DBG_CLK ( Dbg_Clk ),
      .DBG_TDI ( Dbg_TDI ),
      .DBG_TDO ( Dbg_TDO ),
      .DBG_REG_EN ( Dbg_Reg_En ),
      .DBG_CAPTURE ( Dbg_Capture ),
      .DBG_UPDATE ( Dbg_Update ),
      .Trace_Instruction (  ),
      .Trace_Valid_Instr (  ),
      .Trace_PC (  ),
      .Trace_Reg_Write (  ),
      .Trace_Reg_Addr (  ),
      .Trace_MSR_Reg (  ),
      .Trace_New_Reg_Value (  ),
      .Trace_Exception_Taken (  ),
      .Trace_Exception_Kind (  ),
      .Trace_Jump_Taken (  ),
      .Trace_Delay_Slot (  ),
      .Trace_Data_Address (  ),
      .Trace_Data_Access (  ),
      .Trace_Data_Read (  ),
      .Trace_Data_Write (  ),
      .Trace_Data_Write_Value (  ),
      .Trace_Data_Byte_Enable (  ),
      .Trace_DCache_Req (  ),
      .Trace_DCache_Hit (  ),
      .Trace_ICache_Req (  ),
      .Trace_ICache_Hit (  ),
      .Trace_OF_PipeRun (  ),
      .Trace_EX_PipeRun (  ),
      .Trace_MEM_PipeRun (  ),
      .FSL0_S_CLK (  ),
      .FSL0_S_READ (  ),
      .FSL0_S_DATA ( net_gnd32 ),
      .FSL0_S_CONTROL ( net_gnd0 ),
      .FSL0_S_EXISTS ( net_gnd0 ),
      .FSL0_M_CLK (  ),
      .FSL0_M_WRITE ( fsl_v20_0_FSL_M_Write ),
      .FSL0_M_DATA ( fsl_v20_0_FSL_M_Data ),
      .FSL0_M_CONTROL ( fsl_v20_0_FSL_M_Control ),
      .FSL0_M_FULL ( fsl_v20_0_FSL_M_Full ),
      .FSL1_S_CLK (  ),
      .FSL1_S_READ (  ),
      .FSL1_S_DATA ( net_gnd32 ),
      .FSL1_S_CONTROL ( net_gnd0 ),
      .FSL1_S_EXISTS ( net_gnd0 ),
      .FSL1_M_CLK (  ),
      .FSL1_M_WRITE (  ),
      .FSL1_M_DATA (  ),
      .FSL1_M_CONTROL (  ),
      .FSL1_M_FULL ( net_gnd0 ),
      .FSL2_S_CLK (  ),
      .FSL2_S_READ (  ),
      .FSL2_S_DATA ( net_gnd32 ),
      .FSL2_S_CONTROL ( net_gnd0 ),
      .FSL2_S_EXISTS ( net_gnd0 ),
      .FSL2_M_CLK (  ),
      .FSL2_M_WRITE (  ),
      .FSL2_M_DATA (  ),
      .FSL2_M_CONTROL (  ),
      .FSL2_M_FULL ( net_gnd0 ),
      .FSL3_S_CLK (  ),
      .FSL3_S_READ (  ),
      .FSL3_S_DATA ( net_gnd32 ),
      .FSL3_S_CONTROL ( net_gnd0 ),
      .FSL3_S_EXISTS ( net_gnd0 ),
      .FSL3_M_CLK (  ),
      .FSL3_M_WRITE (  ),
      .FSL3_M_DATA (  ),
      .FSL3_M_CONTROL (  ),
      .FSL3_M_FULL ( net_gnd0 ),
      .FSL4_S_CLK (  ),
      .FSL4_S_READ (  ),
      .FSL4_S_DATA ( net_gnd32 ),
      .FSL4_S_CONTROL ( net_gnd0 ),
      .FSL4_S_EXISTS ( net_gnd0 ),
      .FSL4_M_CLK (  ),
      .FSL4_M_WRITE (  ),
      .FSL4_M_DATA (  ),
      .FSL4_M_CONTROL (  ),
      .FSL4_M_FULL ( net_gnd0 ),
      .FSL5_S_CLK (  ),
      .FSL5_S_READ (  ),
      .FSL5_S_DATA ( net_gnd32 ),
      .FSL5_S_CONTROL ( net_gnd0 ),
      .FSL5_S_EXISTS ( net_gnd0 ),
      .FSL5_M_CLK (  ),
      .FSL5_M_WRITE (  ),
      .FSL5_M_DATA (  ),
      .FSL5_M_CONTROL (  ),
      .FSL5_M_FULL ( net_gnd0 ),
      .FSL6_S_CLK (  ),
      .FSL6_S_READ (  ),
      .FSL6_S_DATA ( net_gnd32 ),
      .FSL6_S_CONTROL ( net_gnd0 ),
      .FSL6_S_EXISTS ( net_gnd0 ),
      .FSL6_M_CLK (  ),
      .FSL6_M_WRITE (  ),
      .FSL6_M_DATA (  ),
      .FSL6_M_CONTROL (  ),
      .FSL6_M_FULL ( net_gnd0 ),
      .FSL7_S_CLK (  ),
      .FSL7_S_READ (  ),
      .FSL7_S_DATA ( net_gnd32 ),
      .FSL7_S_CONTROL ( net_gnd0 ),
      .FSL7_S_EXISTS ( net_gnd0 ),
      .FSL7_M_CLK (  ),
      .FSL7_M_WRITE (  ),
      .FSL7_M_DATA (  ),
      .FSL7_M_CONTROL (  ),
      .FSL7_M_FULL ( net_gnd0 ),
      .ICACHE_FSL_IN_CLK (  ),
      .ICACHE_FSL_IN_READ (  ),
      .ICACHE_FSL_IN_DATA ( net_gnd32 ),
      .ICACHE_FSL_IN_CONTROL ( net_gnd0 ),
      .ICACHE_FSL_IN_EXISTS ( net_gnd0 ),
      .ICACHE_FSL_OUT_CLK (  ),
      .ICACHE_FSL_OUT_WRITE (  ),
      .ICACHE_FSL_OUT_DATA (  ),
      .ICACHE_FSL_OUT_CONTROL (  ),
      .ICACHE_FSL_OUT_FULL ( net_gnd0 ),
      .DCACHE_FSL_IN_CLK (  ),
      .DCACHE_FSL_IN_READ (  ),
      .DCACHE_FSL_IN_DATA ( net_gnd32 ),
      .DCACHE_FSL_IN_CONTROL ( net_gnd0 ),
      .DCACHE_FSL_IN_EXISTS ( net_gnd0 ),
      .DCACHE_FSL_OUT_CLK (  ),
      .DCACHE_FSL_OUT_WRITE (  ),
      .DCACHE_FSL_OUT_DATA (  ),
      .DCACHE_FSL_OUT_CONTROL (  ),
      .DCACHE_FSL_OUT_FULL ( net_gnd0 )
    );

  mb_opb_wrapper
    mb_opb (
      .OPB_Clk ( sys_clk_s ),
      .OPB_Rst ( mb_opb_OPB_Rst ),
      .SYS_Rst ( sys_rst_s ),
      .Debug_SYS_Rst ( mb_opb_Debug_SYS_Rst ),
      .WDT_Rst ( net_gnd0 ),
      .M_ABus ( mb_opb_M_ABus ),
      .M_BE ( mb_opb_M_BE ),
      .M_beXfer ( net_gnd2 ),
      .M_busLock ( mb_opb_M_busLock ),
      .M_DBus ( mb_opb_M_DBus ),
      .M_DBusEn ( net_gnd2 ),
      .M_DBusEn32_63 ( net_vcc2 ),
      .M_dwXfer ( net_gnd2 ),
      .M_fwXfer ( net_gnd2 ),
      .M_hwXfer ( net_gnd2 ),
      .M_request ( mb_opb_M_request ),
      .M_RNW ( mb_opb_M_RNW ),
      .M_select ( mb_opb_M_select ),
      .M_seqAddr ( mb_opb_M_seqAddr ),
      .Sl_beAck ( net_gnd3 ),
      .Sl_DBus ( mb_opb_Sl_DBus ),
      .Sl_DBusEn ( net_vcc3 ),
      .Sl_DBusEn32_63 ( net_vcc3 ),
      .Sl_errAck ( mb_opb_Sl_errAck ),
      .Sl_dwAck ( net_gnd3 ),
      .Sl_fwAck ( net_gnd3 ),
      .Sl_hwAck ( net_gnd3 ),
      .Sl_retry ( mb_opb_Sl_retry ),
      .Sl_toutSup ( mb_opb_Sl_toutSup ),
      .Sl_xferAck ( mb_opb_Sl_xferAck ),
      .OPB_MRequest (  ),
      .OPB_ABus ( mb_opb_OPB_ABus ),
      .OPB_BE ( mb_opb_OPB_BE ),
      .OPB_beXfer (  ),
      .OPB_beAck (  ),
      .OPB_busLock (  ),
      .OPB_rdDBus (  ),
      .OPB_wrDBus (  ),
      .OPB_DBus ( mb_opb_OPB_DBus ),
      .OPB_errAck ( mb_opb_OPB_errAck ),
      .OPB_dwAck (  ),
      .OPB_dwXfer (  ),
      .OPB_fwAck (  ),
      .OPB_fwXfer (  ),
      .OPB_hwAck (  ),
      .OPB_hwXfer (  ),
      .OPB_MGrant ( mb_opb_OPB_MGrant ),
      .OPB_pendReq (  ),
      .OPB_retry ( mb_opb_OPB_retry ),
      .OPB_RNW ( mb_opb_OPB_RNW ),
      .OPB_select ( mb_opb_OPB_select ),
      .OPB_seqAddr ( mb_opb_OPB_seqAddr ),
      .OPB_timeout ( mb_opb_OPB_timeout ),
      .OPB_toutSup (  ),
      .OPB_xferAck ( mb_opb_OPB_xferAck )
    );

  debug_module_wrapper
    debug_module (
      .OPB_Clk ( sys_clk_s ),
      .OPB_Rst ( mb_opb_OPB_Rst ),
      .Interrupt (  ),
      .Debug_SYS_Rst ( mb_opb_Debug_SYS_Rst ),
      .Debug_Rst ( Debug_Rst ),
      .Ext_BRK ( Ext_BRK ),
      .Ext_NM_BRK ( Ext_NM_BRK ),
      .OPB_ABus ( mb_opb_OPB_ABus ),
      .OPB_BE ( mb_opb_OPB_BE ),
      .OPB_RNW ( mb_opb_OPB_RNW ),
      .OPB_select ( mb_opb_OPB_select ),
      .OPB_seqAddr ( mb_opb_OPB_seqAddr ),
      .OPB_DBus ( mb_opb_OPB_DBus ),
      .MDM_DBus ( mb_opb_Sl_DBus[0:31] ),
      .MDM_errAck ( mb_opb_Sl_errAck[0] ),
      .MDM_retry ( mb_opb_Sl_retry[0] ),
      .MDM_toutSup ( mb_opb_Sl_toutSup[0] ),
      .MDM_xferAck ( mb_opb_Sl_xferAck[0] ),
      .Dbg_Clk_0 ( Dbg_Clk ),
      .Dbg_TDI_0 ( Dbg_TDI ),
      .Dbg_TDO_0 ( Dbg_TDO ),
      .Dbg_Reg_En_0 ( Dbg_Reg_En ),
      .Dbg_Capture_0 ( Dbg_Capture ),
      .Dbg_Update_0 ( Dbg_Update ),
      .Dbg_Clk_1 (  ),
      .Dbg_TDI_1 (  ),
      .Dbg_TDO_1 ( net_gnd0 ),
      .Dbg_Reg_En_1 (  ),
      .Dbg_Capture_1 (  ),
      .Dbg_Update_1 (  ),
      .Dbg_Clk_2 (  ),
      .Dbg_TDI_2 (  ),
      .Dbg_TDO_2 ( net_gnd0 ),
      .Dbg_Reg_En_2 (  ),
      .Dbg_Capture_2 (  ),
      .Dbg_Update_2 (  ),
      .Dbg_Clk_3 (  ),
      .Dbg_TDI_3 (  ),
      .Dbg_TDO_3 ( net_gnd0 ),
      .Dbg_Reg_En_3 (  ),
      .Dbg_Capture_3 (  ),
      .Dbg_Update_3 (  ),
      .Dbg_Clk_4 (  ),
      .Dbg_TDI_4 (  ),
      .Dbg_TDO_4 ( net_gnd0 ),
      .Dbg_Reg_En_4 (  ),
      .Dbg_Capture_4 (  ),
      .Dbg_Update_4 (  ),
      .Dbg_Clk_5 (  ),
      .Dbg_TDI_5 (  ),
      .Dbg_TDO_5 ( net_gnd0 ),
      .Dbg_Reg_En_5 (  ),
      .Dbg_Capture_5 (  ),
      .Dbg_Update_5 (  ),
      .Dbg_Clk_6 (  ),
      .Dbg_TDI_6 (  ),
      .Dbg_TDO_6 ( net_gnd0 ),
      .Dbg_Reg_En_6 (  ),
      .Dbg_Capture_6 (  ),
      .Dbg_Update_6 (  ),
      .Dbg_Clk_7 (  ),
      .Dbg_TDI_7 (  ),
      .Dbg_TDO_7 ( net_gnd0 ),
      .Dbg_Reg_En_7 (  ),
      .Dbg_Capture_7 (  ),
      .Dbg_Update_7 (  ),
      .bscan_tdi (  ),
      .bscan_reset (  ),
      .bscan_shift (  ),
      .bscan_update (  ),
      .bscan_capture (  ),
      .bscan_sel1 (  ),
      .bscan_drck1 (  ),
      .bscan_tdo1 ( net_gnd0 ),
      .FSL0_S_CLK (  ),
      .FSL0_S_READ (  ),
      .FSL0_S_DATA ( net_gnd32 ),
      .FSL0_S_CONTROL ( net_gnd0 ),
      .FSL0_S_EXISTS ( net_gnd0 ),
      .FSL0_M_CLK (  ),
      .FSL0_M_WRITE (  ),
      .FSL0_M_DATA (  ),
      .FSL0_M_CONTROL (  ),
      .FSL0_M_FULL ( net_gnd0 )
    );

  ilmb_wrapper
    ilmb (
      .LMB_Clk ( sys_clk_s ),
      .SYS_Rst ( sys_rst_s ),
      .LMB_Rst ( ilmb_OPB_Rst ),
      .M_ABus ( ilmb_M_ABus ),
      .M_ReadStrobe ( ilmb_M_ReadStrobe ),
      .M_WriteStrobe ( net_gnd0 ),
      .M_AddrStrobe ( ilmb_M_AddrStrobe ),
      .M_DBus ( net_gnd32 ),
      .M_BE ( net_gnd4 ),
      .Sl_DBus ( ilmb_Sl_DBus ),
      .Sl_Ready ( ilmb_Sl_Ready[0:0] ),
      .LMB_ABus ( ilmb_LMB_ABus ),
      .LMB_ReadStrobe ( ilmb_LMB_ReadStrobe ),
      .LMB_WriteStrobe ( ilmb_LMB_WriteStrobe ),
      .LMB_AddrStrobe ( ilmb_LMB_AddrStrobe ),
      .LMB_ReadDBus ( ilmb_LMB_ReadDBus ),
      .LMB_WriteDBus ( ilmb_LMB_WriteDBus ),
      .LMB_Ready ( ilmb_LMB_Ready ),
      .LMB_BE ( ilmb_LMB_BE )
    );

  dlmb_wrapper
    dlmb (
      .LMB_Clk ( sys_clk_s ),
      .SYS_Rst ( sys_rst_s ),
      .LMB_Rst ( dlmb_OPB_Rst ),
      .M_ABus ( dlmb_M_ABus ),
      .M_ReadStrobe ( dlmb_M_ReadStrobe ),
      .M_WriteStrobe ( dlmb_M_WriteStrobe ),
      .M_AddrStrobe ( dlmb_M_AddrStrobe ),
      .M_DBus ( dlmb_M_DBus ),
      .M_BE ( dlmb_M_BE ),
      .Sl_DBus ( dlmb_Sl_DBus ),
      .Sl_Ready ( dlmb_Sl_Ready[0:0] ),
      .LMB_ABus ( dlmb_LMB_ABus ),
      .LMB_ReadStrobe ( dlmb_LMB_ReadStrobe ),
      .LMB_WriteStrobe ( dlmb_LMB_WriteStrobe ),
      .LMB_AddrStrobe ( dlmb_LMB_AddrStrobe ),
      .LMB_ReadDBus ( dlmb_LMB_ReadDBus ),
      .LMB_WriteDBus ( dlmb_LMB_WriteDBus ),
      .LMB_Ready ( dlmb_LMB_Ready ),
      .LMB_BE ( dlmb_LMB_BE )
    );

  dlmb_cntlr_wrapper
    dlmb_cntlr (
      .LMB_Clk ( sys_clk_s ),
      .LMB_Rst ( dlmb_OPB_Rst ),
      .LMB_ABus ( dlmb_LMB_ABus ),
      .LMB_WriteDBus ( dlmb_LMB_WriteDBus ),
      .LMB_AddrStrobe ( dlmb_LMB_AddrStrobe ),
      .LMB_ReadStrobe ( dlmb_LMB_ReadStrobe ),
      .LMB_WriteStrobe ( dlmb_LMB_WriteStrobe ),
      .LMB_BE ( dlmb_LMB_BE ),
      .Sl_DBus ( dlmb_Sl_DBus ),
      .Sl_Ready ( dlmb_Sl_Ready[0] ),
      .BRAM_Rst_A ( dlmb_cntlr_BRAM_PORT_BRAM_Rst ),
      .BRAM_Clk_A ( dlmb_cntlr_BRAM_PORT_BRAM_Clk ),
      .BRAM_EN_A ( dlmb_cntlr_BRAM_PORT_BRAM_EN ),
      .BRAM_WEN_A ( dlmb_cntlr_BRAM_PORT_BRAM_WEN ),
      .BRAM_Addr_A ( dlmb_cntlr_BRAM_PORT_BRAM_Addr ),
      .BRAM_Din_A ( dlmb_cntlr_BRAM_PORT_BRAM_Din ),
      .BRAM_Dout_A ( dlmb_cntlr_BRAM_PORT_BRAM_Dout )
    );

  ilmb_cntlr_wrapper
    ilmb_cntlr (
      .LMB_Clk ( sys_clk_s ),
      .LMB_Rst ( ilmb_OPB_Rst ),
      .LMB_ABus ( ilmb_LMB_ABus ),
      .LMB_WriteDBus ( ilmb_LMB_WriteDBus ),
      .LMB_AddrStrobe ( ilmb_LMB_AddrStrobe ),
      .LMB_ReadStrobe ( ilmb_LMB_ReadStrobe ),
      .LMB_WriteStrobe ( ilmb_LMB_WriteStrobe ),
      .LMB_BE ( ilmb_LMB_BE ),
      .Sl_DBus ( ilmb_Sl_DBus ),
      .Sl_Ready ( ilmb_Sl_Ready[0] ),
      .BRAM_Rst_A ( ilmb_cntlr_BRAM_PORT_BRAM_Rst ),
      .BRAM_Clk_A ( ilmb_cntlr_BRAM_PORT_BRAM_Clk ),
      .BRAM_EN_A ( ilmb_cntlr_BRAM_PORT_BRAM_EN ),
      .BRAM_WEN_A ( ilmb_cntlr_BRAM_PORT_BRAM_WEN ),
      .BRAM_Addr_A ( ilmb_cntlr_BRAM_PORT_BRAM_Addr ),
      .BRAM_Din_A ( ilmb_cntlr_BRAM_PORT_BRAM_Din ),
      .BRAM_Dout_A ( ilmb_cntlr_BRAM_PORT_BRAM_Dout )
    );

  lmb_bram_wrapper
    lmb_bram (
      .BRAM_Rst_A ( ilmb_cntlr_BRAM_PORT_BRAM_Rst ),
      .BRAM_Clk_A ( ilmb_cntlr_BRAM_PORT_BRAM_Clk ),
      .BRAM_EN_A ( ilmb_cntlr_BRAM_PORT_BRAM_EN ),
      .BRAM_WEN_A ( ilmb_cntlr_BRAM_PORT_BRAM_WEN ),
      .BRAM_Addr_A ( ilmb_cntlr_BRAM_PORT_BRAM_Addr ),
      .BRAM_Din_A ( ilmb_cntlr_BRAM_PORT_BRAM_Din ),
      .BRAM_Dout_A ( ilmb_cntlr_BRAM_PORT_BRAM_Dout ),
      .BRAM_Rst_B ( dlmb_cntlr_BRAM_PORT_BRAM_Rst ),
      .BRAM_Clk_B ( dlmb_cntlr_BRAM_PORT_BRAM_Clk ),
      .BRAM_EN_B ( dlmb_cntlr_BRAM_PORT_BRAM_EN ),
      .BRAM_WEN_B ( dlmb_cntlr_BRAM_PORT_BRAM_WEN ),
      .BRAM_Addr_B ( dlmb_cntlr_BRAM_PORT_BRAM_Addr ),
      .BRAM_Din_B ( dlmb_cntlr_BRAM_PORT_BRAM_Din ),
      .BRAM_Dout_B ( dlmb_cntlr_BRAM_PORT_BRAM_Dout )
    );

  opb_bram_if_cntlr_1_wrapper
    opb_bram_if_cntlr_1 (
      .opb_clk ( sys_clk_s ),
      .opb_rst ( mb_opb_OPB_Rst ),
      .opb_abus ( mb_opb_OPB_ABus ),
      .opb_dbus ( mb_opb_OPB_DBus ),
      .sln_dbus ( mb_opb_Sl_DBus[32:63] ),
      .opb_select ( mb_opb_OPB_select ),
      .opb_rnw ( mb_opb_OPB_RNW ),
      .opb_seqaddr ( mb_opb_OPB_seqAddr ),
      .opb_be ( mb_opb_OPB_BE ),
      .sln_xferack ( mb_opb_Sl_xferAck[1] ),
      .sln_errack ( mb_opb_Sl_errAck[1] ),
      .sln_toutsup ( mb_opb_Sl_toutSup[1] ),
      .sln_retry ( mb_opb_Sl_retry[1] ),
      .bram_rst ( opb_bram_if_cntlr_1_PORTA_BRAM_Rst ),
      .bram_clk ( opb_bram_if_cntlr_1_PORTA_BRAM_Clk ),
      .bram_en ( opb_bram_if_cntlr_1_PORTA_BRAM_EN ),
      .bram_wen ( opb_bram_if_cntlr_1_PORTA_BRAM_WEN ),
      .bram_addr ( opb_bram_if_cntlr_1_PORTA_BRAM_Addr ),
      .bram_din ( opb_bram_if_cntlr_1_PORTA_BRAM_Din ),
      .bram_dout ( opb_bram_if_cntlr_1_PORTA_BRAM_Dout )
    );

  opb_bram_if_cntlr_1_vram_wrapper
    opb_bram_if_cntlr_1_vram (
      .BRAM_Rst_A ( opb_bram_if_cntlr_1_PORTA_BRAM_Rst ),
      .BRAM_Clk_A ( opb_bram_if_cntlr_1_PORTA_BRAM_Clk ),
      .BRAM_EN_A ( opb_bram_if_cntlr_1_PORTA_BRAM_EN ),
      .BRAM_WEN_A ( opb_bram_if_cntlr_1_PORTA_BRAM_WEN ),
      .BRAM_Addr_A ( opb_bram_if_cntlr_1_PORTA_BRAM_Addr ),
      .BRAM_Din_A ( opb_bram_if_cntlr_1_PORTA_BRAM_Din ),
      .BRAM_Dout_A ( opb_bram_if_cntlr_1_PORTA_BRAM_Dout ),
      .BRAM_Rst_B ( net_gnd0 ),
      .BRAM_Clk_B ( pixel_clock ),
      .BRAM_EN_B ( ppu_vram_en ),
      .BRAM_WEN_B ( ppu_vram_wen ),
      .BRAM_Addr_B ( ppu_vram_addr ),
      .BRAM_Din_B ( vram_ppu_Din ),
      .BRAM_Dout_B ( net_gnd32 )
    );

  rs232_uart_1_wrapper
    rs232_uart_1 (
      .OPB_Clk ( sys_clk_s ),
      .OPB_Rst ( mb_opb_OPB_Rst ),
      .Interrupt (  ),
      .OPB_ABus ( mb_opb_OPB_ABus ),
      .OPB_BE ( mb_opb_OPB_BE ),
      .OPB_RNW ( mb_opb_OPB_RNW ),
      .OPB_select ( mb_opb_OPB_select ),
      .OPB_seqAddr ( mb_opb_OPB_seqAddr ),
      .OPB_DBus ( mb_opb_OPB_DBus ),
      .UART_DBus ( mb_opb_Sl_DBus[64:95] ),
      .UART_errAck ( mb_opb_Sl_errAck[2] ),
      .UART_retry ( mb_opb_Sl_retry[2] ),
      .UART_toutSup ( mb_opb_Sl_toutSup[2] ),
      .UART_xferAck ( mb_opb_Sl_xferAck[2] ),
      .RX ( fpga_0_RS232_Uart_1_RX ),
      .TX ( fpga_0_RS232_Uart_1_TX )
    );

  dcm_0_wrapper
    dcm_0 (
      .RST ( net_gnd0 ),
      .CLKIN ( dcm_clk_s ),
      .CLKFB ( dcm_0_FB ),
      .PSEN ( net_gnd0 ),
      .PSINCDEC ( net_gnd0 ),
      .PSCLK ( net_gnd0 ),
      .DSSEN ( net_gnd0 ),
      .CLK0 ( dcm_0_FB ),
      .CLK90 (  ),
      .CLK180 (  ),
      .CLK270 (  ),
      .CLKDV ( sys_clk_s ),
      .CLK2X (  ),
      .CLK2X180 (  ),
      .CLKFX ( pixel_clock ),
      .CLKFX180 (  ),
      .STATUS (  ),
      .LOCKED ( dcm_0_lock ),
      .PSDONE (  )
    );

  reset_block_wrapper
    reset_block (
      .Slowest_sync_clk ( pixel_clock ),
      .Ext_Reset_In ( sys_rst_s ),
      .Aux_Reset_In ( net_gnd0 ),
      .Core_Reset_Req ( net_gnd0 ),
      .Chip_Reset_Req ( net_gnd0 ),
      .System_Reset_Req ( net_gnd0 ),
      .Dcm_locked ( dcm_0_lock ),
      .Rstc405resetcore (  ),
      .Rstc405resetchip (  ),
      .Rstc405resetsys (  ),
      .Bus_Struct_Reset ( sys_bus_reset[0:0] ),
      .Peripheral_Reset (  )
    );

  ppu_0_wrapper
    ppu_0 (
      .FSL_S_CLK (  ),
      .FSL_S_READ ( fsl_v20_0_FSL_S_Read ),
      .FSL_S_DATA ( fsl_v20_0_FSL_S_Data ),
      .FSL_S_CONTROL ( fsl_v20_0_FSL_S_Control ),
      .FSL_S_EXISTS ( fsl_v20_0_FSL_S_Exists ),
      .vram_addr ( ppu_vram_addr ),
      .vram_wen ( ppu_vram_wen ),
      .vram_Din ( vram_ppu_Din ),
      .vram_en ( ppu_vram_en ),
      .fram_addr (  ),
      .fram_wen (  ),
      .fram_Dout ( ppu_fram_Dout ),
      .fram_en (  ),
      .fram_rst (  ),
      .fram_clk (  ),
      .ppu_active ( ppu_active ),
      .ppu_clock ( pixel_clock ),
      .reset ( sys_bus_reset[0] )
    );

  fsl_v20_0_wrapper
    fsl_v20_0 (
      .FSL_Clk ( net_gnd0 ),
      .SYS_Rst ( sys_rst_s ),
      .FSL_Rst (  ),
      .FSL_M_Clk ( sys_clk_s ),
      .FSL_M_Data ( fsl_v20_0_FSL_M_Data ),
      .FSL_M_Control ( fsl_v20_0_FSL_M_Control ),
      .FSL_M_Write ( fsl_v20_0_FSL_M_Write ),
      .FSL_M_Full ( fsl_v20_0_FSL_M_Full ),
      .FSL_S_Clk ( pixel_clock ),
      .FSL_S_Data ( fsl_v20_0_FSL_S_Data ),
      .FSL_S_Control ( fsl_v20_0_FSL_S_Control ),
      .FSL_S_Read ( fsl_v20_0_FSL_S_Read ),
      .FSL_S_Exists ( fsl_v20_0_FSL_S_Exists ),
      .FSL_Full (  ),
      .FSL_Has_Data (  )
    );

endmodule

