#  Simulation Model Generator
#  Xilinx EDK 8.2.02 EDK_Im_Sp2.4
#  Copyright (c) 1995-2006 Xilinx, Inc.  All rights reserved.
#
#  File     system_list.do (Sat Mar 01 21:54:12 2008)
#
#  List Window DO Script File
#
#  List Window DO script files setup the ModelSim List window
#  display for viewing results of the simulation in a tabular
#  format. Comment or uncomment commands to change the set of
#  data values viewed.
#
echo  "Setting up List window display ..."

if { ![info exists xcmdc] } {echo "Warning : c compile command was not run"}
if { ![info exists xcmds] } {echo "Warning : s simulate command was not run"}

onerror { resume }

#  Because EDK did not create the testbench, the user
#  specifies the path to the device under test, $tbpath.
#
if { [info exists PathSeparator] } { set ps $PathSeparator } else { set ps "/" }
if { ![info exists tbpath] } { set tbpath "system" }

#
#  Display top-level ports
#
set binopt {-bin}
set hexopt {-hex}
eval add list $binopt $tbpath${ps}fpga_0_RS232_Uart_1_RX_pin
eval add list $binopt $tbpath${ps}fpga_0_RS232_Uart_1_TX_pin
eval add list $binopt $tbpath${ps}fpga_0_net_gnd_pin
eval add list $binopt $tbpath${ps}fpga_0_net_gnd_1_pin
eval add list $binopt $tbpath${ps}fpga_0_net_gnd_2_pin
eval add list $binopt $tbpath${ps}fpga_0_net_gnd_3_pin
eval add list $binopt $tbpath${ps}fpga_0_net_gnd_4_pin
eval add list $binopt $tbpath${ps}fpga_0_net_gnd_5_pin
eval add list $binopt $tbpath${ps}fpga_0_net_gnd_6_pin
eval add list $binopt $tbpath${ps}sys_clk_pin
eval add list $binopt $tbpath${ps}sys_rst_pin
eval add list $binopt $tbpath${ps}VGA_OUT_PIXEL_CLOCK
eval add list $binopt $tbpath${ps}VGA_COMP_SYNCH_N
eval add list $binopt $tbpath${ps}VGA_OUT_BLANK_N
eval add list $binopt $tbpath${ps}VGA_HSYNCH
eval add list $binopt $tbpath${ps}VGA_VSYNCH
eval add list $hexopt $tbpath${ps}VGA_OUT_RED
eval add list $hexopt $tbpath${ps}VGA_OUT_GREEN
eval add list $hexopt $tbpath${ps}VGA_OUT_BLUE

#
#  Display bus signal ports
#
do ilmb_list.do

do dlmb_list.do

do fsl_v20_0_list.do

do mb_opb_list.do

#
#  Display processor ports
#
do microblaze_0_list.do

#
#  Display processor registers
#

#  Processor registers cannot be displayed for:
#  Module   microblaze_0_wrapper
#  Instance microblaze_0
#  Register display support will be added in the EDK 9.1i release

#
#  Display IP and peripheral ports
#
do lmb_bram_list.do

do opb_bram_if_cntlr_1_vram_list.do

do dcm_0_list.do

do reset_block_list.do

do color_char_mode_svga_ctrl_0_list.do

do debug_module_list.do

do dlmb_cntlr_list.do

do ilmb_cntlr_list.do

do opb_bram_if_cntlr_1_list.do

do rs232_uart_1_list.do

do ppu_0_list.do


#  List window configuration information
#
configure list -delta                 none
configure list -usesignaltriggers     0

#  Define the simulation strobe and period, if used.

configure list -usestrobe             0
configure list -strobestart           {0 ps}  -strobeperiod {0 ps}

configure list -usegating             1
configure list -gateexpr              $tbpath${ps}sys_clk_pin'rising

#  List window setup complete
#
echo  "List window display setup done."
