#  Simulation Model Generator
#  Xilinx EDK 8.2.02 EDK_Im_Sp2.4
#  Copyright (c) 1995-2006 Xilinx, Inc.  All rights reserved.
#
#  File     system_wave.do (Sat Mar 01 21:54:12 2008)
#
#  Wave Window DO Script File
#
#  Wave Window DO script files setup the ModelSim Wave window
#  display for viewing results of the simulation in a graphic
#  format. Comment or uncomment commands to change the set of
#  signals viewed.
#
echo  "Setting up Wave window display ..."

if { ![info exists xcmdc] } {echo "Warning : c compile command was not run"}
if { ![info exists xcmds] } {echo "Warning : s simulate command was not run"}

#  Because EDK did not create the testbench, the user
#  specifies the path to the device under test, $tbpath.
#
if { [info exists PathSeparator] } { set ps $PathSeparator } else { set ps "/" }
if { ![info exists tbpath] } { set tbpath "system" }

#
#  Display top-level ports
#
set binopt {-logic}
set hexopt {-literal -hex}
eval add wave -noupdate -divider {"top-level ports"}
eval add wave -noupdate $binopt $tbpath${ps}fpga_0_RS232_Uart_1_RX_pin
eval add wave -noupdate $binopt $tbpath${ps}fpga_0_RS232_Uart_1_TX_pin
eval add wave -noupdate $binopt $tbpath${ps}fpga_0_net_gnd_pin
eval add wave -noupdate $binopt $tbpath${ps}fpga_0_net_gnd_1_pin
eval add wave -noupdate $binopt $tbpath${ps}fpga_0_net_gnd_2_pin
eval add wave -noupdate $binopt $tbpath${ps}fpga_0_net_gnd_3_pin
eval add wave -noupdate $binopt $tbpath${ps}fpga_0_net_gnd_4_pin
eval add wave -noupdate $binopt $tbpath${ps}fpga_0_net_gnd_5_pin
eval add wave -noupdate $binopt $tbpath${ps}fpga_0_net_gnd_6_pin
eval add wave -noupdate $binopt $tbpath${ps}sys_clk_pin
eval add wave -noupdate $binopt $tbpath${ps}sys_rst_pin
eval add wave -noupdate $binopt $tbpath${ps}VGA_OUT_PIXEL_CLOCK
eval add wave -noupdate $binopt $tbpath${ps}VGA_COMP_SYNCH_N
eval add wave -noupdate $binopt $tbpath${ps}VGA_OUT_BLANK_N
eval add wave -noupdate $binopt $tbpath${ps}VGA_HSYNCH
eval add wave -noupdate $binopt $tbpath${ps}VGA_VSYNCH
eval add wave -noupdate $hexopt $tbpath${ps}VGA_OUT_RED
eval add wave -noupdate $hexopt $tbpath${ps}VGA_OUT_GREEN
eval add wave -noupdate $hexopt $tbpath${ps}VGA_OUT_BLUE

#
#  Display bus signal ports
#
do ilmb_wave.do

do dlmb_wave.do

do fsl_v20_0_wave.do

do mb_opb_wave.do

#
#  Display processor ports
#
do microblaze_0_wave.do

#
#  Display processor registers
#

#  Processor registers cannot be displayed for:
#  Module   microblaze_0_wrapper
#  Instance microblaze_0
#  Register display support will be added in the EDK 9.1i release

#
#  Display IP and peripheral ports
#
do lmb_bram_wave.do

do opb_bram_if_cntlr_1_vram_wave.do

do dcm_0_wave.do

do reset_block_wave.do

do color_char_mode_svga_ctrl_0_wave.do

do debug_module_wave.do

do dlmb_cntlr_wave.do

do ilmb_cntlr_wave.do

do opb_bram_if_cntlr_1_wave.do

do rs232_uart_1_wave.do

do ppu_0_wave.do


#  Wave window configuration information
#
configure  wave -justifyvalue          right
configure  wave -signalnamewidth       1

TreeUpdate [SetDefaultTree]

#  Wave window setup complete
#
echo  "Wave window display setup done."
