-------------------------------------------------------------------------------
-- color_char_mode_svga_ctrl_0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

entity color_char_mode_svga_ctrl_0_wrapper is
  port (
    VGA_OUT_PIXEL_CLOCK : out std_logic;
    VGA_COMP_SYNCH_N : out std_logic;
    VGA_OUT_BLANK_N : out std_logic;
    VGA_HSYNCH : out std_logic;
    VGA_VSYNCH : out std_logic;
    VGA_OUT_RED : out std_logic_vector(7 downto 0);
    VGA_OUT_GREEN : out std_logic_vector(7 downto 0);
    VGA_OUT_BLUE : out std_logic_vector(7 downto 0);
    bram_char_addr : out std_logic_vector(0 to 31);
    bram_wen : out std_logic_vector(0 to 3);
    BRAM_Din : in std_logic_vector(0 to 31);
    char_read_enable : out std_logic;
    pixel_clock : in std_logic;
    reset : in std_logic
  );
end color_char_mode_svga_ctrl_0_wrapper;

architecture STRUCTURE of color_char_mode_svga_ctrl_0_wrapper is

  component color_char_mode_svga_ctrl is
    port (
      VGA_OUT_PIXEL_CLOCK : out std_logic;
      VGA_COMP_SYNCH_N : out std_logic;
      VGA_OUT_BLANK_N : out std_logic;
      VGA_HSYNCH : out std_logic;
      VGA_VSYNCH : out std_logic;
      VGA_OUT_RED : out std_logic_vector(7 downto 0);
      VGA_OUT_GREEN : out std_logic_vector(7 downto 0);
      VGA_OUT_BLUE : out std_logic_vector(7 downto 0);
      bram_char_addr : out std_logic_vector(0 to 31);
      bram_wen : out std_logic_vector(0 to 3);
      BRAM_Din : in std_logic_vector(0 to 31);
      char_read_enable : out std_logic;
      pixel_clock : in std_logic;
      reset : in std_logic
    );
  end component;

begin

  color_char_mode_svga_ctrl_0 : color_char_mode_svga_ctrl
    port map (
      VGA_OUT_PIXEL_CLOCK => VGA_OUT_PIXEL_CLOCK,
      VGA_COMP_SYNCH_N => VGA_COMP_SYNCH_N,
      VGA_OUT_BLANK_N => VGA_OUT_BLANK_N,
      VGA_HSYNCH => VGA_HSYNCH,
      VGA_VSYNCH => VGA_VSYNCH,
      VGA_OUT_RED => VGA_OUT_RED,
      VGA_OUT_GREEN => VGA_OUT_GREEN,
      VGA_OUT_BLUE => VGA_OUT_BLUE,
      bram_char_addr => bram_char_addr,
      bram_wen => bram_wen,
      BRAM_Din => BRAM_Din,
      char_read_enable => char_read_enable,
      pixel_clock => pixel_clock,
      reset => reset
    );

end architecture STRUCTURE;

