//-----------------------------------------------------------------------------
// ppu_0_wrapper.v
//-----------------------------------------------------------------------------

module ppu_0_wrapper
  (
    FSL_S_CLK,
    FSL_S_READ,
    FSL_S_DATA,
    FSL_S_CONTROL,
    FSL_S_EXISTS,
    vram_addr,
    vram_wen,
    vram_Din,
    vram_en,
    fram_addr,
    fram_wen,
    fram_Dout,
    fram_en,
    fram_rst,
    fram_clk,
    ppu_active,
    ppu_clock,
    reset
  );
  output FSL_S_CLK;
  output FSL_S_READ;
  input [0:31] FSL_S_DATA;
  input FSL_S_CONTROL;
  input FSL_S_EXISTS;
  output [0:31] vram_addr;
  output [0:3] vram_wen;
  input [0:31] vram_Din;
  output vram_en;
  output [0:14] fram_addr;
  output [0:3] fram_wen;
  output [0:23] fram_Dout;
  output fram_en;
  output fram_rst;
  output fram_clk;
  input ppu_active;
  input ppu_clock;
  input reset;

  ppu
    ppu_0 (
      .FSL_S_CLK ( FSL_S_CLK ),
      .FSL_S_READ ( FSL_S_READ ),
      .FSL_S_DATA ( FSL_S_DATA ),
      .FSL_S_CONTROL ( FSL_S_CONTROL ),
      .FSL_S_EXISTS ( FSL_S_EXISTS ),
      .vram_addr ( vram_addr ),
      .vram_wen ( vram_wen ),
      .vram_Din ( vram_Din ),
      .vram_en ( vram_en ),
      .fram_addr ( fram_addr ),
      .fram_wen ( fram_wen ),
      .fram_Dout ( fram_Dout ),
      .fram_en ( fram_en ),
      .fram_rst ( fram_rst ),
      .fram_clk ( fram_clk ),
      .ppu_active ( ppu_active ),
      .ppu_clock ( ppu_clock ),
      .reset ( reset )
    );

endmodule

